/*
 * Created on Jul 16, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package at.gv.bmi.szr.client;

import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

/**
 * Erweitert den HashVector soweit, dass alle beinhaltende Objekte vom Type <code>String</code>
 * sind. hnlich dem <code>java.util.Properties</code>, nur knnen mehrere Strings
 * unter einem Schlssel gespeichert und gelesen werden. 
 * 
 * @author Oliver Ehrenmller
 */
public class PropertiesVector extends HashVector {

	private static final long serialVersionUID = -2350363843241283882L;

	public String getProperty(String key) {
		return (String) super.get(key);
	}

	public String getProperty(String key, String defaultValue) {
		return super.containsKey(key) ? (String) super.get(key) : defaultValue;
	}

	public String[] getAllProperties(String key) {
		Vector vector = super.getAll(key);
		String[] array = new String[vector.size()];
		for (int i = 0; i < array.length; i++)
			array[i] = (String) vector.get(i);
		return array;
	}

	public void setProperty(String key, String value) {
		super.put(key, value);
	}

	public void setProperty(String key, String value, boolean override) {
		super.put(key, value, override);
	}

	public synchronized Object put(Object key, Object value) {
		if (!(key instanceof String))
			throw new IllegalArgumentException("key ist kein String");
		if (!(value instanceof String))
			throw new IllegalArgumentException("value ist kein String");
		super.put(key, value);
		return null;
	}

	public synchronized void putAll(Map map) {
	}

	public synchronized void putAllStrings(Map map) {
		Iterator iterator = map.keySet().iterator();
		Object key, value;
		while (iterator.hasNext()) {
			key = iterator.next();
			if (key instanceof String && (value = map.get(key)) instanceof String)
				super.put(key, value);
		}
	}

}
